package cn.com.origin.autocode.jfom.util;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.UnsupportedEncodingException;
import java.util.Iterator;
import java.util.Map;
import java.util.Map.Entry;
import java.util.Set;

import org.apache.commons.httpclient.DefaultHttpMethodRetryHandler;
import org.apache.commons.httpclient.HttpClient;
import org.apache.commons.httpclient.HttpStatus;
import org.apache.commons.httpclient.NameValuePair;
import org.apache.commons.httpclient.methods.GetMethod;
import org.apache.commons.httpclient.methods.PostMethod;
import org.apache.commons.httpclient.params.HttpMethodParams;

public class HttpUtil {

	public static String doGet(String url) {
		// 
		InputStream is = null;
		BufferedReader br = null;
		String result = null;
		// httpClientʵ
		HttpClient httpClient = new HttpClient();
		// httpʱʱ䣺15000
		// Ȼȡӹٻȡ,ٽвĸֵ
		httpClient.getHttpConnectionManager().getParams().setConnectionTimeout(15000);
		// һGetʵ
		GetMethod getMethod = new GetMethod(url);
		// getʱΪ60000
		getMethod.getParams().setParameter(HttpMethodParams.SO_TIMEOUT, 60000);
		// ԻƣĬԴ3ΣΪtrueԻƿãfalse෴
		getMethod.getParams().setParameter(HttpMethodParams.RETRY_HANDLER, new DefaultHttpMethodRetryHandler(3, true));
		try {
			// ִGet
			int statusCode = httpClient.executeMethod(getMethod);
			// жϷ
			if (statusCode != HttpStatus.SC_OK) {
				// ״̬뷵صĲok,˵ʧ,ӡϢ
				System.err.println("Method faild: " + getMethod.getStatusLine());
			} else {
				// ͨgetMethodʵȡԶ̵һ
				is = getMethod.getResponseBodyAsStream();
				// װ
				br = new BufferedReader(new InputStreamReader(is, "UTF-8"));

				StringBuffer sbf = new StringBuffer();
				// ȡװ
				String temp = null;
				while ((temp = br.readLine()) != null) {
					sbf.append(temp).append("\r\n");
				}

				result = sbf.toString();
			}

		} catch (IOException e) {
			e.printStackTrace();
		} finally {
			// رԴ
			if (null != br) {
				try {
					br.close();
				} catch (IOException e) {
					e.printStackTrace();
				}
			}
			if (null != is) {
				try {
					is.close();
				} catch (IOException e) {
					e.printStackTrace();
				}
			}
			// ͷ
			getMethod.releaseConnection();
		}
		return result;
	}

	public static String doPost(String url, Map<String, Object> paramMap) {
		// ȡ
		InputStream is = null;
		BufferedReader br = null;
		String result = null;
		// httpClientʵ
		HttpClient httpClient = new HttpClient();
		// httpClientʱʱ䣺15000
		httpClient.getHttpConnectionManager().getParams().setConnectionTimeout(15000);
		// post󷽷ʵ
		PostMethod postMethod = new PostMethod(url);
		// postʱʱ
		postMethod.getParams().setParameter(HttpMethodParams.SO_TIMEOUT, 60000);

		NameValuePair[] nvp = null;
		// жϲmapparamMapǷΪ
		if (null != paramMap && paramMap.size() > 0) {// Ϊ
			// ֵ飬СΪĸ
			nvp = new NameValuePair[paramMap.size()];
			// ѭmap
			Set<Entry<String, Object>> entrySet = paramMap.entrySet();
			// ȡ
			Iterator<Entry<String, Object>> iterator = entrySet.iterator();

			int index = 0;
			while (iterator.hasNext()) {
				Entry<String, Object> mapEntry = iterator.next();
				// mapEntryлȡkeyvalueֵŵ
				try {
					nvp[index] = new NameValuePair(mapEntry.getKey(),
							new String(mapEntry.getValue().toString().getBytes("UTF-8"), "UTF-8"));
				} catch (UnsupportedEncodingException e) {
					e.printStackTrace();
				}
				index++;
			}
		}
		// жnvpǷΪ
		if (null != nvp && nvp.length > 0) {
			// ŵrequestBody
			postMethod.setRequestBody(nvp);
		}
		// ִPOST
		try {
			int statusCode = httpClient.executeMethod(postMethod);
			// жǷɹ
			if (statusCode != HttpStatus.SC_OK) {
				System.err.println("Method faild: " + postMethod.getStatusLine());
			}
			// ȡԶ̷ص
			is = postMethod.getResponseBodyAsStream();
			// װ
			br = new BufferedReader(new InputStreamReader(is, "UTF-8"));

			StringBuffer sbf = new StringBuffer();
			String temp = null;
			while ((temp = br.readLine()) != null) {
				sbf.append(temp).append("\r\n");
			}

			result = sbf.toString();
		} catch (IOException e) {
			e.printStackTrace();
		} finally {
			// رԴ
			if (null != br) {
				try {
					br.close();
				} catch (IOException e) {
					e.printStackTrace();
				}
			}
			if (null != is) {
				try {
					is.close();
				} catch (IOException e) {
					e.printStackTrace();
				}
			}
			// ͷ
			postMethod.releaseConnection();
		}
		return result;
	}
}