package cn.com.origin.autocode.jfom.util;

import java.util.ArrayList;
import java.util.List;

import net.sf.json.JSONArray;

/**
 * @copyRight 㽭տƼ޹˾
 * @author  E-mail:hub@connor.net.cn
 * @date ʱ䣺2018-2-26 10:26:29
 * @version v1.0
 * @parameter
 * @since
 * @return
 */

public class JsonTest {

	public static void main(String[] args) {
		JsonTest test = new JsonTest();
		test.printJson();

	}

	public void printJson() {
		ProjMsgBean pb = new ProjMsgBean();

		List<MaterialMsgBean> materialS = new ArrayList();
		MaterialMsgBean mb1 = new MaterialMsgBean("11", "mname1", "puid1");
		MaterialMsgBean mb2 = new MaterialMsgBean("22", "mname2", "puid2");
		MaterialMsgBean mb3 = new MaterialMsgBean("33", "mname3", "puid3");
		materialS.add(mb1);
		materialS.add(mb2);
		materialS.add(mb3);

		List<ProjMemberBean> projMemberS = new ArrayList();
		ProjMemberBean pmb1 = new ProjMemberBean("member1");
		ProjMemberBean pmb2 = new ProjMemberBean("member2");
		projMemberS.add(pmb1);
		projMemberS.add(pmb2);
		// ProjMemberBean pmb3 = new ProjMemberBean("member3");
		pb.setMaterialS(materialS);
		pb.setProjMemberS(projMemberS);

		List<ProjMsgBean> pbList = new ArrayList();

		pbList.add(pb);

		objectToJson(pbList);

	}

	public String objectToJson(List<ProjMsgBean> projectS) {
		String str = null;
		try {
			JSONArray json = JSONArray.fromObject(projectS);// javaתΪjson
			str = json.toString();// jsonתΪַ
		} catch (Exception e) {
			e.printStackTrace();
		}
		System.out.println("JSON =>" + str);
		return str;
	}

	public class ProjMsgBean {
		private String project_ID;
		private String object_name;
		private String fu8cxmc;
		private String fu8cpxl;
		private String fu8dw;
		private String fu8zzdw;
		private String fu8zjkh;
		private String fu8oem;
		private String fu8renming;
		private String fu8ots;
		private String fu8ppap;
		private String fu8sopdata;
		private String fu8zcl;
		private String fu8state;
		private List<MaterialMsgBean> materialS;
		private List<ProjMemberBean> projMemberS;

		public String getProject_ID() {
			return project_ID;
		}

		public void setProject_ID(String project_ID) {
			this.project_ID = project_ID;
		}

		public String getObject_name() {
			return object_name;
		}

		public void setObject_name(String object_name) {
			this.object_name = object_name;
		}

		public String getFu8cxmc() {
			return fu8cxmc;
		}

		public void setFu8cxmc(String fu8cxmc) {
			this.fu8cxmc = fu8cxmc;
		}

		public String getFu8cpxl() {
			return fu8cpxl;
		}

		public void setFu8cpxl(String fu8cpxl) {
			this.fu8cpxl = fu8cpxl;
		}

		public String getFu8dw() {
			return fu8dw;
		}

		public void setFu8dw(String fu8dw) {
			this.fu8dw = fu8dw;
		}

		public String getFu8zzdw() {
			return fu8zzdw;
		}

		public void setFu8zzdw(String fu8zzdw) {
			this.fu8zzdw = fu8zzdw;
		}

		public String getFu8zjkh() {
			return fu8zjkh;
		}

		public void setFu8zjkh(String fu8zjkh) {
			this.fu8zjkh = fu8zjkh;
		}

		public String getFu8oem() {
			return fu8oem;
		}

		public void setFu8oem(String fu8oem) {
			this.fu8oem = fu8oem;
		}

		public String getFu8renming() {
			return fu8renming;
		}

		public void setFu8renming(String fu8renming) {
			this.fu8renming = fu8renming;
		}

		public String getFu8ots() {
			return fu8ots;
		}

		public void setFu8ots(String fu8ots) {
			this.fu8ots = fu8ots;
		}

		public String getFu8ppap() {
			return fu8ppap;
		}

		public void setFu8ppap(String fu8ppap) {
			this.fu8ppap = fu8ppap;
		}

		public String getFu8sopdata() {
			return fu8sopdata;
		}

		public void setFu8sopdata(String fu8sopdata) {
			this.fu8sopdata = fu8sopdata;
		}

		public String getFu8zcl() {
			return fu8zcl;
		}

		public void setFu8zcl(String fu8zcl) {
			this.fu8zcl = fu8zcl;
		}

		public String getFu8state() {
			return fu8state;
		}

		public void setFu8state(String fu8state) {
			this.fu8state = fu8state;
		}

		public List<MaterialMsgBean> getMaterialS() {
			return materialS;
		}

		public void setMaterialS(List<MaterialMsgBean> materialS) {
			this.materialS = materialS;
		}

		public List<ProjMemberBean> getProjMemberS() {
			return projMemberS;
		}

		public void setProjMemberS(List<ProjMemberBean> projMemberS) {
			this.projMemberS = projMemberS;
		}

	}

	public class MaterialMsgBean {
		private String custMaterialNo;
		private String custMaterialName;
		private String oaMaterialUid;

		public MaterialMsgBean(String custMaterialNo, String custMaterialName,
				String oaMaterialUid) {

			this.custMaterialNo = custMaterialNo;
			this.custMaterialName = custMaterialName;
			this.oaMaterialUid = oaMaterialUid;
		}

		public String getCustMaterialNo() {
			return custMaterialNo;
		}

		public void setCustMaterialNo(String custMaterialNo) {
			this.custMaterialNo = custMaterialNo;
		}

		public String getCustMaterialName() {
			return custMaterialName;
		}

		public void setCustMaterialName(String custMaterialName) {
			this.custMaterialName = custMaterialName;
		}

		public String getOaMaterialUid() {
			return oaMaterialUid;
		}

		public void setOaMaterialUid(String oaMaterialUid) {
			this.oaMaterialUid = oaMaterialUid;
		}

	}

	public class ProjMemberBean {
		private String projMember;

		public ProjMemberBean(String projMember) {

			this.projMember = projMember;
		}

		public String getProjMember() {
			return projMember;
		}

		public void setProjMember(String projMember) {
			this.projMember = projMember;
		}

	}

}
